
// Opcode Enums values are any integer < 128. Values greater than 127 are
// reserved.

#include <assert.h>
#include <string.h>

#define OPCODE_ENUM(VARIANT)     \
   VARIANT(Opcode_NONE, 0)       \
   VARIANT(Opcode_HELP, 1)       \
   VARIANT(Opcode_CHANNELDATA, 2)\
   VARIANT(Opcode_RESET, 3)      \
   VARIANT(Opcode_SETREFV, 4)

#define OPCODE_ENUM_VARIANT(NAME, VALUE) NAME = (VALUE),

typedef enum
{
   OPCODE_ENUM(OPCODE_ENUM_VARIANT)
} Opcode;


#define OPCODE_ENUM_STRING(NAME, ...) case NAME: return #NAME;
#define OPCODE_ENUM_FROM_STRING(NAME, ...)           \
   if (0 == strcmp(string, #NAME)) return NAME;

const char *opcode_name(Opcode opcode)
{
   switch(opcode)
   {
      OPCODE_ENUM(OPCODE_ENUM_STRING)
      default: assert(!"Unknown opcode");
   }
}

Opcode opcode_from_string(const char *string)
{
   OPCODE_ENUM(OPCODE_ENUM_FROM_STRING)
   assert(!"Uknown opcode");
}


